<?php

namespace Intergo\AnalyticsClient;

use Intergo\BaseClient\Responses\BaseResponseInterface;

abstract class AbstractAnalyticsService
{
    /** @var AnalyticsClient */
    private $client;

    /**
     * AnalyticsService constructor.
     *
     * @param $baseUrl
     * @param $traceId
     */
    public function __construct($baseUrl, $traceId)
    {
        $this->client = new AnalyticsClient($baseUrl, $traceId);
    }

    /**
     * Send events to our "service-analytics" (https://github.com/intergo/service-analytics).
     *
     * @see https://app.asana.com/0/1202041647164570/1203587484023149/f
     * @param int|string $client_id
     * @param int $user_id
     * @param array $events
     * @return BaseResponseInterface
     */
    public function send($client_id, $user_id, array $events = [])
    {
        return $this->client->execute(__FUNCTION__, [], get_defined_vars());
    }
}
